#include "../cthugha.h"
#include "../sound.h"
#include "../options.h"
#include "../cd_player.h"
#include "../network.h"
#include "../keys.h"
#include "../server.h"
#include "../interface.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/soundcard.h>
#include <math.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <ncurses.h>


interface_mode_t interface_mode = IM_main;

char * cthugha_mode_text() {
    return "serv";
}
/*
 * Get a "line" of sound from the soundcard 
 */
int serv_sound_read() {

    if( nr_clients == 0) {		/* if no client connected, */
	free_sound();			/* we don't need the sound device */
	return 0;
    }

    alloc_sound();			/* make sure we have the sound dev */

    sound_read();

    return 0;
}

int cth_init(int * argc, char * argv[]) {

    server = 1;

    return 0;
}

int cth_main() {
    int key = ' ';

    free_sound();

    do {
	(key == ' ') ? clear() : erase(); 

	serv_sound_read();
	broadcast_sound();

	server_accept();

	cd_check();
	key=cd_player();

	print_clients();

	refresh();

	if(srv_wait_time)			/* wait for a short while */
	    usleep(srv_wait_time*1000);		/* to give clients a chance */
						/* to display everything */
    } while( (key != CK_ESC) && (key != 'q') && (key != 'Q') );

    return 0;
}
